// DRAWxtl V5.1 main window header
// initial version generated by Fast Light User Interface Designer (fluid) version 1.0104
// Coded using the FLTK 1.1.6 widget set
//
//     Larry W. Finger, Martin Kroeker and Brian Toby
//

#ifndef DRAWxtlViewUI_h
#define DRAWxtlViewUI_h
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Menu_.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Progress.H>
#include <FL/x.H>
#include "drawxtl.h"
#include "CrystalView.h"
#include "Draw_Fl_Input.h"

void About_Help_cb(void);
void Edit_Arrow_cb(void);
void Check_Box_cb(void);
void Color_Help_cb(void);
void Configure_cb(void);
void Edit_Bond_cb(void);
void Edit_STR_cb(Fl_Menu_*, void*);
void Edit_Parmeters_cb(void);
void Edit_Polyhedra_cb(void);
void Edit_Slab_cb(void);
void Edit_Spheres_cb(void);
void Edit_Ellipsoid_cb(void);
void ImportDataFile_cb(Fl_Widget *, void *);
void Edit_LonePair_cb(void);
void Edit_Maps_cb(void);
void Exit_cb(void);
void Graphics_Cursor_cb(void);
void Graphics_Help_cb(void);
void Input_Help_cb(void);
void Max_Min_cb(void);
void next_focus(void);
void Offset_cb(void);
void Rotation_cb(void);
void SelectDataFile_cb(void);
void Dump_View_cb(void);
void View_POV_cb(void);
void View_Listing_cb(void);
void View_Console_cb(void);
void Window_Exit_cb(void);
void Save_Current_cb(void);
void Spacegroup_Help_cb(void);

#define LIST1 1
#define LIST2 2
#define HELP 4
#define HELP1 8
#define TEXTWIN 16
#define SPHERE 32
#define ELLIPSOID 64
#define LONEPAIR 128
#define TEXT1 256

class DRAWxtlViewUI {
public:
  void show(int , char **);
  DRAWxtlViewUI();                  // constructor

// pointers to widgets

  Fl_Multiline_Output * Cursor_pos; 
  Fl_Output * CurDirBuf;
  Fl_Output * CurStrBuf;
  Fl_Text_Buffer * CutoutColorBuf;
  Fl_Double_Window *mainWindow;
  Fl_Check_Button *Use_Clipping;
  Flu_Spinner *X_Min;
  Flu_Spinner *Y_Min;
  Flu_Spinner *Z_Min;
  Flu_Spinner *X_Max;
  Flu_Spinner *Y_Max;
  Flu_Spinner *Z_Max;
  Flu_Spinner *X_Min_clip;
  Flu_Spinner *Y_Min_clip;
  Flu_Spinner *Z_Min_clip;
  Flu_Spinner *X_Max_clip;
  Flu_Spinner *Y_Max_clip;
  Flu_Spinner *Z_Max_clip;
  Draw_Fl_Input *Origin_X;
  Draw_Fl_Input *Origin_Y;
  Draw_Fl_Input *Origin_Z;
  Draw_Fl_Input *X_Rot;
  Draw_Fl_Input *Y_Rot;
  Draw_Fl_Input *Z_Rot;
  Fl_Output *CurFile;
  Fl_Output *CurDir;
  Fl_Check_Button *Generate_VRML1;
  Fl_Output * Origin1_Msg;
  Fl_Check_Button *Orthographic_View;
  Fl_Check_Button *Show_Vector_Triple;
  static Fl_Menu_Item drawxtl_menu[];
  Flu_Combo_List * Frame_No;
  Fl_Group *ViewGroup;
  Fl_Box *cframe;
  CrystalView *crystal;

// variables used in drawing

  GLuint crystalDL;
  int destroy;               // window destructor flag variable
  int frame_no;              // number of frame being processed
  int max_frame;             // maximum number of frames
  int Str_File_Changed;      // set true (==1) if contents of str file changed
  float X_Boxlim;            // X box limit read from command line
  float Y_Boxlim;            // Y box limit read from command line
  float Z_Boxlim;            // Z box limit read from command line
  float X_Origin;            // X origin read from command line
  float Y_Origin;            // Y origin read from command line
  float Z_Origin;            // Z origin read from command line
  float lookat_v1[3], lookat_v2[3]; // "lookat" vectors "
  float label_scale;         // relative scaling of text labels
  int noshadow;              // if true, no shadows in POV
  float ambient;             // POV lighting options
  float diffuse;             //
  float specular;            //
  float roughness;           //
  float clip_lim[MAX_FRAME][6]; /* limits of clip box in cell coords */
  float cryst_lim[MAX_FRAME][6];/* limits of view box in cell coords */
  float Trans[3];            // translation of virtual trackball
#if !defined (WIN32) && !defined (__APPLE__)
  Pixmap icon;               // icon used if NOT WIN32
#endif

// symmetry variables
  
  char spg[3][4];            // space group code
  int ss[24][3][3];          // rotation operators for symmetry
  float rss[24][3][3];       // unitary rotation operators for symmetry
  float lat_pos[4][3];       // coordinates of lattice points
  float ts[24][3];           // translation operators
  int sym_op_no[192];        // saved symmetry operation number
  float cell_xyz[192][3];    // storage for generated equiv. positions
  int sys;                   // crystal system indicator
  int nbr;                   // Bravais lattice indicator
  int acentric;              // true if non-centric space group
  int ng;                    // number of rotation operations to specify group
  int nlat;                  // number of lattice positions
  float xyzoff[3];           // offset between origin and center of symmetry
  int xyzoff_read;           // true if xyzoff line read
  int origin1_flag;          // true if space group has alternate origin setting
  float origin_offset[3];    // offset vector between settings

// lattice constant variables
  
  float lat_con[6];          // lattice constants
  float rec_lat_con[3];      // reciprocal lengths
  double b_mat[3][3];        // metric tensor
  float ginv[3][3];          // direct space metric tensor

// lattice parameters of cutout box 

  float slab_con[6];         // lattice constants
  float slab_off[3];         // offset
  float slab_rot[3];         // rotation angles
  
// variables for atom lists

  float atom_xyz[MAX_ATOM][3];// atomic coordinates
  char atom_l[MAX_ATOM][5];  // atom labels
  int atom_n[MAX_ATOM];      // input atom number
  int atom_fn[MAX_ATOM];     // frame number for atom
  int sv_atom_n[MAX_ATOM];   // saved input atom number
  int *atom_no;              // master list atom and symmetry number
  int *orig_atom_no;         // saved atom number
  int TF_status[MAX_ATOM];   // Temperature factor status (-1 no Uij, 0 sphere, 1 ellipsoid)

// cone parameters
  
  int ncone;                  // number of different types of lonepair cones
  char cone_l1[MAX_CONE][5];  // label for atom end of cone
  int numlonepairs[MAX_CONE]; // number of lone pairs to draw at atom
  float cone_height[MAX_CONE];// height of cone
  float cone_min[MAX_CONE];   // cone tip radius
  float cone_max[MAX_CONE];   // cone base radius
  char col_cone_v[MAX_CONE][40];// color and properties of cones for VRML
  char col_cone_p[MAX_CONE][40];// color and properties of cones for POV
  int cone_fn[MAX_CONE];      // frame number for the cone commands

// magnetic arrow parameters

  int nmag;                       // number of magnetic moments
  int arrow_fn[MAX_ARROW];        // saved frame number
  char col_arrow_p[MAX_ARROW][40];// arrow color
  char col_arrow_v[MAX_ARROW][40];// arrow color
  float arrow_length[MAX_ARROW];  // length of mag. arrow
  float arrow_diam[MAX_ARROW];    // diameter of magnetic arrow
  float mag_matrix[3][3];         // transformation between magnetic and nuclear cell
  float mag_xp[MAX_ARROW][3];     // position of arrow in real-space cell
  float mag_xc[MAX_ARROW][3];     // components of arrow wrt XYZ

// polyhedra parameters

  int npoly;                  // number of different types of polyhedra
  int poly_fn[MAX_POLY];      // frame number for polyhedra commands
  float polylimit;            // should be close to zero to allow only regular polygonal faces
  char poly_l[MAX_POLY][5];   // polyhedral center label
  char poly_t[MAX_POLY][5];   // polyhedral vertex label
  float poly_size[MAX_POLY];  // size of polyhedron
  float poly_min[MAX_POLY];   // lower limit for shell-like polyhedron
  char poly_col_v[MAX_POLY][40];// polyhedron colors for VRML
  char poly_col_p[MAX_POLY][40];// polyhedron colors for POV
  float p_rad_edge[MAX_POLY]; // individual edge radius for polyhedron
  char p_col_edge_v[MAX_POLY][40]; // color of poly edges for VRML
  char p_col_edge_p[MAX_POLY][40]; // color of individual poly edges for POV

// plane parameters

  int nplane;                      // number of different types of planes
  int plane_fn[MAX_PLANE];         // frame number for plane commands
  char plane_col_v[MAX_PLANE][40]; // plane colors for VRML
  char plane_col_p[MAX_PLANE][40]; // plane colors for POV 
  char plane_l[MAX_PLANE][5];      // plane center label
  float plane_size[MAX_PLANE];     // size of plane coordination

// bond parameters

  int nbond;                       // number of different types of bonds
  int bond_fn[MAX_BOND];           // frame number for bond commands
  char bond_l1[MAX_BOND][5];       // label for one end of bond
  char bond_l2[MAX_BOND][5];       // label for other end
  float bond_size[MAX_BOND];       // bond diameter
  float bond_min[MAX_BOND];        // minimum bond distance
  float bond_max[MAX_BOND];        // maximum bond distance
  char col_bond_v[MAX_BOND][40];   // color and properties of bonds for VRML
  char col_bond_p[MAX_BOND][40];   // color and properties of bonds for POV
  int bond_style[MAX_BOND];	   // solid bond or dash
  float Bond_Mult;                 // Multiplier for Bond Size
  float BndMult;                   // Bond multiplier initialization
  float mol_d;                     // intramolecular distance for molecular and polyhedral completion

// sphere parameters

  int sphere_fn[MAX_SPHERE];         // frame number for sphere commands
  char sphere_l[MAX_SPHERE][5];      // sphere label
  int  sphere_n[MAX_SPHERE];         // atom number - -1 for old behavior
  float sphere_size[MAX_SPHERE];     // sphere size
  char sphere_col_v[MAX_SPHERE][40]; // sphere colors
  char sphere_col_p[MAX_SPHERE][40]; // sphere colors
  float Sphere_Mult;                 // Multiplier for Sphere Size
  float SpMult;                      // initialization for Sphere_Mult
  int nsphere;                       // number of different types of spheres


// background parameters

  char col_bg_p[40];           // Background color in POV file
  char col_bg_v[40];           // Background color in VRML file
  float glback[3];             // Background RGB values for openGL

// ellipsoid parameters

  int  auto_ellipse;             // true if ellipsoids should be automatically generated
  char ellips_col_v[MAX_EL][40]; // ellipsoid colors for VRML
  char ellips_col_p[MAX_EL][40]; // ellipsoid colors for POV
  float ellips_EV[MAX_EL][3][3]; // Eigenvectors
  float ellips_RMS[MAX_EL][3];   // RMS amplitudes
  char ellips_l[MAX_EL][5];      // label for anisotropic atom
  int ellips_n[MAX_EL];          // atom number
  int save_el_number[MAX_EL];    // save original atom number
  int ell_type[MAX_EL];          // form of ellipsoid input
  float ellips[MAX_EL][6];       // thermal ellipsoid coefficients
  float Phong_Value;             // reflectivity value for Phong highlighting
  float Phong_Size;              // Phong highlighting size
  char Cutout_color[40];         // color of cutout section

// text label parameters

  int nlabel;                    // number of textual labels
  int label_fn[MAX_LABELS];      // frame number
  float label_x[MAX_LABELS][3];  // position of textual labels
  char label_label[MAX_LABELS][64]; // label text
  float saved_x_label[2][4][3];  // place to save coordinates of each type of label
  int labels_inited;             // set to true when labels initialized
  int triple[4];                 // label numbers of the parts of the triple vector
  int autolabel;		 // set to true when import adds atom labels
// miscellaneous variables

  double Old_Xrot;               // Used to determine if str file changed
  double Old_Yrot;               // Used to determine if str file changed
  double Old_Zrot;               // Used to determine if str file changed
  float cur_step;

// file variables

  FILE *fpin, *flout;        
  FILE *fpoutv;
  FILE *fpoutp;
  FILE *fcns;
  char Cur_Console[256];     // file strings
  char Cur_Dir[256];
  char Cur_File[256];
  char Cur_Temp[256];
  char Cur_Listing[256];
  char Cur_Root[256];
  char DRAWxtl_Path[256];
  char EditName[256];
  char FileViewName[256];
  char POV_Include[256];
  char POV_Options[256];
  char POV_Path[256];
  char DefaultFinish[256];
  char VRML_Path[256];
  char LoadOnStartup[10];
  char ProgramPath[256];
};

#endif
