#ifndef DRAWxtl_h
#define DRAWxtl_h
#define VERSION "V5.1"
#define MAX_ATOM 1000            /* Maximum number of atoms in asymmetric unit */
#define MAX_EL 200				 /* Maximum number of anisotropic atoms */
#define MAX_POLY 30				 /* Maximum number of polyhedral types */
#define MAX_PLANE 30             /* Maximum number of plane types */
#define MAX_BOND 50				 /* Maximum number of bond types */
#define MAX_CONE 10				 /* Maximum number of lone pair cone types */
#define MAX_SPHERE 30            /* Maximum number of sphere types */
#define MAX_ARROW 30             /* maximum number of arroow types */
#define RAD 57.2957795           /* Conversion from radians to degrees */
#define MAX_VERTS 20000          /* Maximum number of generated vertices */
#define MAX_LABELS 1000          /* Maximum number of textual labels */
#define MAX_FRAME 5              // Maximum number of frames
#define MAX_MAP_CONTOUR 10       /* Maximum number of map contours */
#ifndef PI
#define PI 3.1415926
#endif
#define O_OPT 1
#define B_OPT 2
#define P_OPT 4
#define V_OPT 8
#define M_OPT 16
#define L_OPT 32
#define IDI_ICON1  101
#define BUFSIZE 512
struct MAP_INFO
{
    int info_valid;
    char title[82];
    float lat_con[6];
    float rhomx;
    float rhomn;
    int map_int[3];
    float xlim[2];
    float ylim[2];
    float zlim[2];
    int map_type;
};
#endif
